-- ud_220_20191106.sql
-- B979E677D7A0B5B4CEB3030130120B16

create or alter procedure BUILD_REPORT (
    D1 date not null,
    D2 date not null,
    TI1 varchar(1),
    TI2 varchar(1))
returns (
    CSMO char(5),
    KOL integer)
as
begin
  for select K.SMO, count(*)
      from KARTA K
      inner join SMO S on S.SMOCOD = K.SMO
      where (not K.DATE_1 is null) and
            (not K.DATE_2 is null) and
            (K.DATE_ENTER >= :D1) and
            (K.DATE_ENTER <= :D2) and
            (not K.MD5_HASH is null) and
            (S.TF = '37000') and
            (K.TD >= :TI1) and
            (K.TD <= :TI2)
      group by K.SMO
      having count(*) > 0
      order by K.SMO
      into :CSMO, :KOL
  do
    suspend;   

  for select count(*)
      from KARTA K
        -- inner join SMO S on S.SMOCOD = K.SMO
        left join SMO S on S.SMOCOD = K.SMO
      where (not K.DATE_1 is null) and
            (not K.DATE_2 is null) and
            (K.DATE_ENTER >= :D1) and
            (K.DATE_ENTER <= :D2) and
            (not K.MD5_HASH is null) and
             --(S.TF <> '37000') and
             (S.TF is null) and
            (K.TD >= :TI1) and
            (K.TD <= :TI2) having count(*) > 0
      into :KOL
  do
  begin
    CSMO = '45000';   
    suspend;    
  end
end; @

create or alter procedure DELETE_REPORT2 (
    ID_REPORT integer)
as
begin
  delete from SANK S
  where exists(select K.IDK
               from KARTA K
               where (K.IDK = S.IDK) and
                     (K.ID_REP = :ID_REPORT));

  delete from KARTA_NAZR kn
  where kn.idk in (select K.IDK
               from KARTA K
               where (K.ID_REP = :ID_REPORT));

  delete from KARTA_RISK kr
  where kr.idk in (select K.IDK
               from KARTA K
               where (K.ID_REP = :ID_REPORT));

  delete from KARTA_RSLT krslt
  where krslt.idk in (select K.IDK
               from KARTA K
               where (K.ID_REP = :ID_REPORT));

  delete from KARTA_USL ku
  where ku.idk in (select K.IDK
               from KARTA K
               where (K.ID_REP = :ID_REPORT));

  delete from DS kds
  where kds.idk in (select K.IDK
               from KARTA K
               where (K.ID_REP = :ID_REPORT));
                       
  delete from KARTA K
  where (K.ID_REP = :ID_REPORT);

  delete from REPORT R
  where R.ID_REP = :ID_REPORT;  
end; @

COMMIT WORK; @						